## cegui-mk2 0.8.4+dfsg

=== CMakeLists.txt ===
################################################################################
# Top-level CMakeLists.txt file for Crazy Eddie's GUI System
################################################################################
cmake_minimum_required(VERSION 2.8)
if (POLICY CMP0017)
    cmake_policy(SET CMP0017 OLD)
endif()

if (POLICY CMP0045)
    cmake_policy(SET CMP0045 OLD)
endif()

set (CMAKE_MODULE_PATH "${CMAKE_SOURCE_DIR}/cmake")
include(CEGUIMacros)
include(CMakeDependentOption)

if (APPLE AND NOT CMAKE_OSX_ARCHITECTURES)
    set( CMAKE_OSX_ARCHITECTURES x86_64 CACHE STRING "Build architectures for Mac OS X")
endif()

# default to Release build (it's what most people will use, except cegui devs)
if (NOT CMAKE_BUILD_TYPE)
    set( CMAKE_BUILD_TYPE Release CACHE STRING "Sets the configuration to build (Release, Debug, etc...)")
endif()

################################################################################
# Start of main Project definitions
################################################################################
project(cegui)

################################################################################
# Set up version information
################################################################################
set( CEGUI_VERSION_MAJOR 0)
set( CEGUI_VERSION_MINOR 8)
set( CEGUI_VERSION_PATCH 4)
set( CEGUI_VERSION ${CEGUI_VERSION_MAJOR}.${CEGUI_VERSION_MINOR}.${CEGUI_VERSION_PATCH} )

#
# This controls the binary versioning - which is different to release versions
# defined above.
#
# The following describes what these components are and how they are intended to
# be managed.
# 
#   - CURRENT: The binary interface version provided by the library.
#   - REVISION: Revision of binary interface specified in CURRENT
#   - AGE: Number of previous binary interfaces this library is compatible with.
#
# Prior to issuing a release, modify the values as follows:
#   - If there were any changes in the source, increase REVISION.
#   - If the interface changed at all, increase CURRENT and set REVISION to 0
#   - If the interface had binary compabilbe additions only (so no ABI breaking
#     changes) increase AGE, else set AGE to 0.
#
set( CEGUI_ABI_CURRENT 5)
set( CEGUI_ABI_REVISION 0)
set( CEGUI_ABI_AGE 3)
MATH( EXPR CEGUI_SOVERSION ${CEGUI_ABI_CURRENT}-${CEGUI_ABI_AGE} )
set( CEGUI_ABI_VERSION ${CEGUI_SOVERSION}.${CEGUI_ABI_AGE}.${CEGUI_ABI_REVISION} )


################################################################################
# Check for libs and other packages we might use.
################################################################################
# be sure to search the provided dependencies on Win32 and Mac OS X platforms
if ((WIN32 OR APPLE) AND NOT CMAKE_PREFIX_PATH)
    set (CMAKE_PREFIX_PATH "${CMAKE_SOURCE_DIR}/dependencies" CACHE PATH "Path to dependencies")
    # prefer the dylib deps in the dependencies over some other framework
    set (CMAKE_FIND_FRAMEWORK LAST)
endif()

# Look for packages
find_package(PCRE)
find_package(Freetype)
find_package(Minizip)
find_package(Fribidi)
if (NOT WIN32)
    find_package(Iconv REQUIRED)
endif()

find_package(OpenGL)
find_package(GLEW)
find_package(GLM)
find_package(GLFW)
find_package(DirectXSDK)
find_package(D3DX11Effects)
find_package(Irrlicht)
find_package(Ogre)
find_package(OIS)
find_package(DirectFB)
find_package(OpenGLES)

find_package(EXPAT)
find_package(XercesC)
find_package(LibXml2)
find_package(TinyXML)
find_package(RapidXML)

find_package(DevIL)
find_package(FreeImage)
find_package(SILLY)
find_package(Corona)
find_package(PVRTools)

find_package(Lua51)
find_package(TOLUAPP)
find_package(PythonInterp)
find_package(PythonLibs)
find_package(Boost 1.36.0 COMPONENTS python unit_test_framework system)

find_package(Doxygen)
find_package(GTK2 COMPONENTS gtk)
# set for consistency with other deps
set (GTK2_INCLUDE_DIR ${GTK2_INCLUDE_DIRS})


################################################################################
# Define the configurable options
################################################################################
cmake_dependent_option( CEGUI_MSVC_STATIC_RUNTIME "Specifies whether to the static runtime (/MT and /MTd) or the DLL runtime (/MD and /MDd).
NOTE: This will also affect which set of dependency libraries are linked with." FALSE "MSVC" FALSE )
cmake_dependent_option( CEGUI_BUILD_SHARED_LIBS_WITH_STATIC_DEPENDENCIES "For WIN32 and APPLE where the dependency pack is used, prefer the static
dependency libs over the shared/dynamic ones.  NOTE: On Windows you also need to
be mindful of which C/C++ runtime setting has been used to compile the various
components - they must all match or you will get crashes, heap corruption and/or
other issues." FALSE "WIN32 OR APPLE" FALSE)
option( CEGUI_BUILD_STATIC_CONFIGURATION "Specifies whether the static configs will be built.  (NB: Shared configs are always built)" FALSE)
option( CEGUI_BUILD_STATIC_FACTORY_MODULE "For static CEGUI builds, specifies whether to include the getWindoFactoryModule method.  When false, the developer must provide a custom implementation of the method" FALSE)
# sanity check on static build option for factory method
if (CEGUI_BUILD_STATIC_FACTORY_MODULE AND NOT CEGUI_BUILD_STATIC_CONFIGURATION)
  message(SEND_ERROR "You may not enable CEGUI_BUILD_STATIC_FACTORY_MODULE without CEGUI_BUILD_STATIC_CONFIGURATION enabled.  CEGUI needs to be built statically if building the static factory method.")
endif()
option( CEGUI_CUSTOM_ALLOCATORS "If checked, CEGUI can use custom allocation. (for experienced developers only!)" FALSE )
cmake_dependent_option( CEGUI_CUSTOM_ALLOCATORS_DEBUG "If checked, CEGUI allocations will pass debug info to allocators. (only used if CEGUI_CUSTOM_ALLOCATORS is checked)" FALSE "CEGUI_CUSTOM_ALLOCATORS" FALSE )
set( CEGUI_CUSTOM_ALLOCATORS_INCLUDE "CEGUI/MemoryStdAllocator.h" CACHE STRING "Which include file contains memory allocators and allocation configuration. (only used if CEGUI_CUSTOM_ALLOCATORS is checked)
We have bundled 2 allocators, mostly for demonstrational purposes.
CEGUI/MemoryStdAllocator.h contains malloc allocator, use it as a starting point for your own allocators
CEGUI/MemoryOgreAllocator.h delegates allocation to Ogre, which may be useful to Ogre users (you will have to manually change linking options of CEGUIBase!)" )

set( CEGUI_STRING_CLASS 1 CACHE INT "Which string class should CEGUI use
1 - utf8 and utf32 aware inbuilt string,
2 - std::string without custom allocation,
3 - std::basic_string allocated according to allocator config" )

# sanity check std::basic_string and allocator and allocators actually being used
if (${CEGUI_STRING_CLASS} MATCHES 3 AND NOT CEGUI_CUSTOM_ALLOCATORS)
    message(SEND_ERROR "You requested std::basic_string allocated according to allocator as CEGUI::String even though CEGUI is not being built with custom allocators enabled!")
endif()

option( CEGUI_HAS_FREETYPE "Specifies whether to include Freetype font support" ${FREETYPE_FOUND} )
option( CEGUI_HAS_PCRE_REGEX "Specifies whether to include PCRE regexp matching for editbox string validation" ${PCRE_FOUND} )
option( CEGUI_HAS_MINIZIP_RESOURCE_PROVIDER "Specifies whether to build the minizip based resource provider" ${MINIZIP_FOUND} )
option( CEGUI_HAS_DEFAULT_LOGGER "Specifies whether to build the DefaultLogger implementation" TRUE)

option( CEGUI_BUILD_XMLPARSER_EXPAT "Specifies whether to build the Expat based XMLParser module" ${EXPAT_FOUND} )
option( CEGUI_BUILD_XMLPARSER_XERCES "Specifies whether to build the Xerces-C++ based XMLParser module" ${XERCESC_FOUND} )
option( CEGUI_BUILD_XMLPARSER_LIBXML2 "Specifies whether to build the libxml2 based XMLParser module" ${LIBXML2_FOUND} )
option( CEGUI_BUILD_XMLPARSER_RAPIDXML "Specifies whether to build the RapidXML based XMLParser module" ${RAPIDXML_FOUND} )
option( CEGUI_BUILD_XMLPARSER_TINYXML "Specifies whether to build the TinyXML based XMLParser module" ${TINYXML_FOUND} )

option( CEGUI_BUILD_IMAGECODEC_SILLY "Specifies whether to build the SILLY based ImageCodec module" ${SILLY_FOUND} )
option( CEGUI_BUILD_IMAGECODEC_DEVIL "Specifies whether to build the DevIL based ImageCodec module" ${IL_FOUND} )
option( CEGUI_BUILD_IMAGECODEC_FREEIMAGE "Specifies whether to build the FreeImage based ImageCodec module" ${FREEIMAGE_FOUND} )
option( CEGUI_BUILD_IMAGECODEC_CORONA "Specifies whether to build the Corona based ImageCodec module" ${CORONA_FOUND} )
option( CEGUI_BUILD_IMAGECODEC_STB "Specifies whether to build the STB based ImageCodec module" FALSE )
option( CEGUI_BUILD_IMAGECODEC_TGA "Specifies whether to build the based TGA only ImageCodec module" FALSE )
option( CEGUI_BUILD_IMAGECODEC_PVR "Specifies whether to build the PVR only ImageCodec module" ${PVRTOOLS_FOUND} )

cegui_dependent_option( CEGUI_BUILD_RENDERER_OPENGL "Specifies whether to build the OpenGL renderer module" "OPENGL_FOUND;GLM_FOUND;GLEW_FOUND" )
cegui_dependent_option( CEGUI_BUILD_RENDERER_OPENGL3 "Specifies whether to build the OpenGL 3+ (core profile) renderer module" "OPENGL_FOUND;GLM_FOUND;GLEW_FOUND")
option( CEGUI_BUILD_RENDERER_OGRE "Specifies whether to build the Ogre renderer module" ${OGRE_FOUND} )
option( CEGUI_BUILD_RENDERER_IRRLICHT "Specifies whether to build the Irrlicht renderer module" ${IRRLICHT_FOUND} )
option( CEGUI_BUILD_RENDERER_DIRECTFB "Specifies whether to build the DirectFB renderer module (not supported!)" FALSE )
cegui_dependent_option( CEGUI_BUILD_RENDERER_DIRECT3D9 "Specifies whether to build the Direct3D 9 renderer module" "DIRECTXSDK_FOUND;NOT DIRECTXSDK_MAX_D3D LESS 9" )
cegui_dependent_option( CEGUI_BUILD_RENDERER_DIRECT3D10 "Specifies whether to build the Direct3D 10 renderer module" "DIRECTXSDK_FOUND;NOT DIRECTXSDK_MAX_D3D LESS 10" )
cegui_dependent_option( CEGUI_BUILD_RENDERER_DIRECT3D11 "Specifies whether to build the Direct3D 11 renderer module" "DIRECTXSDK_FOUND;D3DX11EFFECTS_FOUND;NOT DIRECTXSDK_MAX_D3D LESS 11" )
option( CEGUI_BUILD_RENDERER_NULL "Specifies whether to build the null renderer module" FALSE )
option( CEGUI_BUILD_RENDERER_OPENGLES "Specifies whether to build the OpenGLES renderer module" ${OPENGLES_FOUND} )

cegui_dependent_option( CEGUI_BUILD_LUA_MODULE "Specifies whether to build the Lua based script module" "LUA51_FOUND;TOLUAPP_FOUND" )
cegui_dependent_option( CEGUI_BUILD_LUA_GENERATOR "Specifies whether to build the custom tolua binding generator 'toluappcegui'" "LUA51_FOUND;TOLUAPP_FOUND" )

cegui_dependent_option( CEGUI_BUILD_PYTHON_MODULES "Specifies whether to build the Python extension module(s)" "PYTHONINTERP_FOUND;PYTHONLIBS_FOUND;Boost_PYTHON_FOUND" )

option( CEGUI_OPTION_SAFE_LUA_MODULE "Specifies whether to enable extra validation in the Lua script module in non-debug builds" FALSE )

cegui_dependent_option( CEGUI_USE_FRIBIDI "Specifies whether bi-directional text will be supported via the fribidi library." "FRIBIDI_FOUND" )
cegui_dependent_option( CEGUI_USE_MINIBIDI "Specifies whether bi-directional text will be supported via the embedded minibidi." FALSE )

# sanity check on bidi options
if (CEGUI_USE_MINIBIDI AND CEGUI_USE_FRIBIDI)
    message(SEND_ERROR "You may not enable both CEGUI_USE_FRIBIDI and CEGUI_USE_MINIBIDI. Please choose only one of these options.")
endif()

# This vile construct is needed because of things that changed in boost and the
# total fail that is Ogre forcing its boost dependency onto its clients.
if (CEGUI_BUILD_RENDERER_OGRE AND OIS_FOUND)
    if (NOT Boost_VERSION LESS 105000 AND "${OGRE_THREAD_PROVIDER}" STREQUAL "1") #Check additionally if we use boost as thread provider at all
        if (Boost_SYSTEM_FOUND)
            set (CEGUI_OGRE_SAMPLES_EXTRALIBS ${Boost_SYSTEM_LIBRARY})
            set (CEGUI_OGRE_SAMPLES_AVAILABLE TRUE)
        else()
            set (CEGUI_OGRE_SAMPLES_EXTRALIBS)
            set (CEGUI_OGRE_SAMPLES_AVAILABLE FALSE)
        endif()
    else()
        set (CEGUI_OGRE_SAMPLES_EXTRALIBS)
        set (CEGUI_OGRE_SAMPLES_AVAILABLE TRUE)
    endif()

=== datafiles/CMakeLists.txt ===
install(DIRECTORY animations DESTINATION ${CEGUI_DATA_INSTALL_DIR})
#install(DIRECTORY configs DESTINATION ${CEGUI_DATA_INSTALL_SUBDIR})
install(DIRECTORY fonts DESTINATION ${CEGUI_DATA_INSTALL_DIR})
install(DIRECTORY imagesets DESTINATION ${CEGUI_DATA_INSTALL_DIR})
install(DIRECTORY layouts DESTINATION ${CEGUI_DATA_INSTALL_DIR})
install(DIRECTORY looknfeel DESTINATION ${CEGUI_DATA_INSTALL_DIR})
install(DIRECTORY lua_scripts DESTINATION ${CEGUI_DATA_INSTALL_DIR})
install(DIRECTORY schemes DESTINATION ${CEGUI_DATA_INSTALL_DIR})
install(DIRECTORY xml_schemas DESTINATION ${CEGUI_DATA_INSTALL_DIR})

=== samples/CMakeLists.txt ===
# We clear the samples.xml file, which will be used by the samples browser, and
# add the samples header to it before starting to add the samples 
file(WRITE ${CMAKE_BINARY_DIR}/datafiles/samples/samples.xml "")
file(READ ${CMAKE_CURRENT_SOURCE_DIR}/common/SamplesXmlHeader.xml DEMO_META_DATA)
file(APPEND ${CMAKE_BINARY_DIR}/datafiles/samples/samples.xml ${DEMO_META_DATA})

add_subdirectory(HelloWorld)
add_subdirectory(WidgetDemo)
add_subdirectory(EffectsDemo)
add_subdirectory(FontDemo)

add_subdirectory(Demo6)
add_subdirectory(DragDropDemo)
add_subdirectory(EditboxValidationDemo)
add_subdirectory(GameMenu)
add_subdirectory(HUDDemo)
add_subdirectory(InventoryDemo)
add_subdirectory(Minesweeper)
add_subdirectory(ScrollablePaneDemo)
add_subdirectory(TabControlDemo)
add_subdirectory(TextDemo)
add_subdirectory(TreeDemo)
add_subdirectory(CommonDialogsDemo)

if (CEGUI_BUILD_LUA_MODULE)
    # add_subdirectory(Demo8)
endif()

# Simple test for GLES renderer.
#
# Commented since it's does not use the samples framework and is merely included
# such that recreation from scratch is not required in the future.  Aka, it's
# one of CrazyEddie's hacks that he wants to keep around :-p
#if (CEGUI_BUILD_RENDERER_OPENGLES)
#    add_subdirectory(GLESTest)
#endif()


# Finally we add the samples footer to the samples.xml
file(READ ${CMAKE_CURRENT_SOURCE_DIR}/common/SamplesXmlFooter.xml DEMO_META_DATA)
file(APPEND ${CMAKE_BINARY_DIR}/datafiles/samples/samples.xml ${DEMO_META_DATA})

# And add it to the install
install(FILES ${CMAKE_BINARY_DIR}/datafiles/samples/samples.xml
        DESTINATION ${CEGUI_DATA_INSTALL_DIR}/samples/)

=== samples_framework/CMakeLists.txt ===
# We check if the required dependencies are available for the sample framework

if(CEGUI_BUILD_RENDERER_OGRE AND NOT CEGUI_OGRE_SAMPLES_AVAILABLE)
    message(SEND_ERROR "The Samples and the OgreRenderer are enabled, but Ogre dependencies are missing (boost). Please add the dependencies and run 'Configure' in CMake again.")
endif()
if(CEGUI_BUILD_RENDERER_OPENGL OR CEGUI_BUILD_RENDERER_OPENGL3)
    if(NOT GLFW_FOUND)
        message(SEND_ERROR "The Samples and the OpenGL or OpenGL3+ Renderer are enabled - GLFW is required for this configuration but was not found. Please add GFLW to your dependencies and run 'Configure' in CMake again.")
    endif()
endif()


set( CEGUI_TARGET_NAME ${CEGUI_SAMPLEFRAMEWORK_EXENAME} )

set( CORE_SOURCE_FILES
    ./src/SamplesFrameworkBase.cpp
    ./src/SamplesFramework.cpp
    ./src/CEGuiBaseApplication.cpp
    ./src/CEGuiRendererSelector.cpp
    ./src/Samples_xmlHandler.cpp
    ./src/SampleData.cpp
    ./src/MetaDataWindowManager.cpp
    ./src/SamplesBrowserManager.cpp
)

set( CORE_HEADER_FILES
    ../samples/common/include/Sample.h
    ./include/SamplesFrameworkBase.h
    ./include/SamplesFramework.h
    ./include/CEGuiBaseApplication.h
    ./include/CEGuiRendererSelector.h
    ./include/Samples_xmlHandler.h
    ./include/SampleData.h
    ./include/MetaDataWindowManager.h
    ./include/SamplesBrowserManager.h
)


include_directories(${CMAKE_SOURCE_DIR}/samples_framework/include
                    ${CMAKE_BINARY_DIR}/samples/common/include
                    ${CMAKE_SOURCE_DIR}/samples/common/include
                    ${CMAKE_SOURCE_DIR}/cegui/include)

if (WIN32)
    list (APPEND CORE_SOURCE_FILES
        ./src/Win32AppHelper.cpp
        ./src/Win32CEGuiRendererSelector.cpp
    )
elseif (APPLE)
    list (APPEND CORE_SOURCE_FILES
        ./src/MacCEGuiRendererSelector.mm
    )
elseif (CEGUI_SAMPLES_USE_GTK2)
    list (APPEND CORE_SOURCE_FILES
        ./src/GTK2CEGuiRendererSelector.cpp
    )
else()
    list (APPEND CORE_SOURCE_FILES
        ./src/CLICEGuiRendererSelector.cpp
    )
endif()


if (CEGUI_BUILD_RENDERER_OPENGL OR CEGUI_BUILD_RENDERER_OPENGL3)
    list (APPEND CORE_SOURCE_FILES
        ./src/CEGuiGLFWSharedBase.cpp
    )
endif()

if (CEGUI_BUILD_RENDERER_OPENGL)
    list (APPEND CORE_SOURCE_FILES
        ./src/CEGuiOpenGLBaseApplication.cpp
    )
endif()

if (CEGUI_BUILD_RENDERER_OPENGL3)
    list (APPEND CORE_SOURCE_FILES
        ./src/CEGuiOpenGL3BaseApplication.cpp
    )
endif()

if (CEGUI_OGRE_SAMPLES_AVAILABLE)
    # this prevents the boost auto-link dis-feature
    add_definitions(-DBOOST_ALL_NO_LIB)

    list (APPEND CORE_SOURCE_FILES
        ./src/CEGuiOgreBaseApplication.cpp
    )
endif()

if (CEGUI_BUILD_RENDERER_IRRLICHT)
    list (APPEND CORE_SOURCE_FILES
        ./src/CEGuiIrrlichtBaseApplication.cpp
    )
endif()

if (CEGUI_BUILD_RENDERER_DIRECT3D9)
    list (APPEND CORE_SOURCE_FILES
        ./src/CEGuiD3D9BaseApplication.cpp
        ./src/DeviceReset_Direct3D9.cpp
    )
endif()

if (CEGUI_BUILD_RENDERER_DIRECT3D10)
    list (APPEND CORE_SOURCE_FILES
        ./src/CEGuiD3D10BaseApplication.cpp
        ./src/DeviceReset_Direct3D10.cpp
    )
endif()

if (CEGUI_BUILD_RENDERER_DIRECT3D11)
    list (APPEND CORE_SOURCE_FILES
        ./src/CEGuiD3D11BaseApplication.cpp
        ./src/DeviceReset_Direct3D11.cpp
    )
endif()

if (CEGUI_BUILD_RENDERER_DIRECTFB)
    list (APPEND CORE_SOURCE_FILES
        ./src/CEGuiDirectFBBaseApplication.cpp
    )
endif()

if (CEGUI_BUILD_RENDERER_DIRECT3D9 OR CEGUI_BUILD_RENDERER_DIRECT3D10 OR CEGUI_BUILD_RENDERER_DIRECT3D11)
    include_directories(${DIRECTXSDK_INCLUDE_DIR})
    link_directories(${DIRECTXSDK_LIBRARY_DIR})
endif()

###########################################################################
#                     Statically Linked Executable
###########################################################################
if (CEGUI_BUILD_STATIC_CONFIGURATION)
    add_executable(${CEGUI_TARGET_NAME}_Static ${CORE_SOURCE_FILES} ${CORE_HEADER_FILES})
    set_property(TARGET ${CEGUI_TARGET_NAME}_Static APPEND PROPERTY COMPILE_DEFINITIONS CEGUI_STATIC)

    # append the _d (or whatever) for debug builds as needed.
    if (CEGUI_HAS_BUILD_SUFFIX AND CEGUI_BUILD_SUFFIX)
        set_target_properties(${CEGUI_TARGET_NAME}_Static PROPERTIES
            OUTPUT_NAME_DEBUG "${CEGUI_TARGET_NAME}_Static${CEGUI_BUILD_SUFFIX}"
        )
    endif()

    # This works around an issue in the prebuilt deps and can be removed once those are fixed :)
    if (WIN32)
        set_target_properties(${CEGUI_TARGET_NAME}_Static PROPERTIES LINK_FLAGS_DEBUG /NODEFAULTLIB:freeglut.lib)
    endif()

    if (APPLE)
        cegui_apple_app_setup(${CEGUI_TARGET_NAME}_Static TRUE)
    endif()
endif()

###########################################################################
#                   Dynamically Linked Executable
###########################################################################
add_executable(${CEGUI_TARGET_NAME} ${CORE_SOURCE_FILES} ${CORE_HEADER_FILES})

# append the _d (or whatever) for debug builds as needed.
if (CEGUI_HAS_BUILD_SUFFIX AND CEGUI_BUILD_SUFFIX)
    set_target_properties(${CEGUI_TARGET_NAME} PROPERTIES
        OUTPUT_NAME_DEBUG "${CEGUI_TARGET_NAME}${CEGUI_BUILD_SUFFIX}"
    )
endif()

if (NOT APPLE AND CEGUI_INSTALL_WITH_RPATH)
    set_target_properties(${CEGUI_TARGET_NAME} PROPERTIES
        INSTALL_RPATH "${CMAKE_INSTALL_PREFIX}/${CEGUI_LIB_INSTALL_DIR}"
    )
endif()

if (APPLE)
    # we add these to ensure the dynamically loaded modules we will be
    # using are built before the .app's post build step that copies
    # libs into the app bundle.
    add_dependencies(${CEGUI_TARGET_NAME} ${CEGUI_CORE_WR_LIBNAME}
                                          CEGUI${CEGUI_OPTION_DEFAULT_XMLPARSER}
                                          CEGUI${CEGUI_OPTION_DEFAULT_IMAGECODEC}
    )

    cegui_apple_app_setup(${CEGUI_TARGET_NAME} FALSE)
endif()

###########################################################################
#                    MSVC PROJ USER FILE TEMPLATES
###########################################################################
if (MSVC)
    configure_file(
        ${CMAKE_MODULE_PATH}/templates/VisualStudioUserFile.vcproj.user.in
        ${CMAKE_CURRENT_BINARY_DIR}/${CEGUI_TARGET_NAME}.vcproj.user
        @ONLY
    )
    configure_file(
        ${CMAKE_MODULE_PATH}/templates/VisualStudioUserFile.vcxproj.user.in
        ${CMAKE_CURRENT_BINARY_DIR}/${CEGUI_TARGET_NAME}.vcxproj.user
        @ONLY
    )
endif ()


###########################################################################
#                      LIBRARY LINK SETUP
###########################################################################
cegui_target_link_libraries(${CEGUI_TARGET_NAME} ${CEGUI_BASE_LIBNAME})

if (CEGUI_BUILD_STATIC_CONFIGURATION)
    target_link_libraries(${CEGUI_TARGET_NAME}_Static
        ${CEGUI_STATIC_XMLPARSER_MODULE}_Static
        ${CEGUI_STATIC_IMAGECODEC_MODULE}_Static
        ${CEGUI_CORE_WR_LIBNAME}_Static
    )
endif()

###########################################################################
#  BUILD DEPENDENCIES FOR THE SHARED LIBRARIES USED BY THE SAMPLEBROWSER
###########################################################################

add_dependencies(${CEGUI_TARGET_NAME} ${CEGUI_CORE_WR_LIBNAME}
                                      CEGUI${CEGUI_OPTION_DEFAULT_XMLPARSER}
                                      CEGUI${CEGUI_OPTION_DEFAULT_IMAGECODEC})
                                      
if (CEGUI_SAMPLES_ENABLE_COMMON_DIALOGUES_DEMO)
    add_dependencies(${CEGUI_TARGET_NAME} ${CEGUI_COMMON_DIALOGS_LIBNAME})
endif()

###########################################################################
#                           INSTALLATION
###########################################################################
install(TARGETS ${CEGUI_TARGET_NAME}
    RUNTIME DESTINATION bin
    LIBRARY DESTINATION ${CEGUI_LIB_INSTALL_DIR}
    ARCHIVE DESTINATION ${CEGUI_LIB_INSTALL_DIR}
    BUNDLE DESTINATION ${CEGUI_LIB_INSTALL_DIR}
)

if (CEGUI_BUILD_STATIC_CONFIGURATION)
    install(TARGETS ${CEGUI_TARGET_NAME}_Static
        RUNTIME DESTINATION bin
        LIBRARY DESTINATION ${CEGUI_LIB_INSTALL_DIR}
        ARCHIVE DESTINATION ${CEGUI_LIB_INSTALL_DIR}
        BUNDLE DESTINATION ${CEGUI_LIB_INSTALL_DIR}
)
endif()

if (CEGUI_BUILD_RENDERER_OPENGL OR CEGUI_BUILD_RENDERER_OPENGL3)
    cegui_add_dependency(${CEGUI_TARGET_NAME} OPENGL)
    cegui_add_dependency(${CEGUI_TARGET_NAME} GLFW)
    cegui_target_link_libraries(${CEGUI_TARGET_NAME} ${CEGUI_OPENGL_RENDERER_LIBNAME})
endif()

if (CEGUI_BUILD_RENDERER_OGRE)
    cegui_add_dependency(${CEGUI_TARGET_NAME} OGRE)
    cegui_add_dependency(${CEGUI_TARGET_NAME} OIS)
    cegui_target_link_libraries(${CEGUI_TARGET_NAME} ${CEGUI_OGRE_RENDERER_LIBNAME} ${CEGUI_OGRE_SAMPLES_EXTRALIBS})
endif()

if (CEGUI_BUILD_RENDERER_IRRLICHT)
    cegui_add_dependency(${CEGUI_TARGET_NAME} IRRLICHT)
    cegui_target_link_libraries(${CEGUI_TARGET_NAME} ${CEGUI_IRRLICHT_RENDERER_LIBNAME})
endif()

if (CEGUI_BUILD_RENDERER_DIRECT3D9 OR CEGUI_BUILD_RENDERER_DIRECT3D10 OR CEGUI_BUILD_RENDERER_DIRECT3D11)
    cegui_target_link_libraries(${CEGUI_TARGET_NAME} dxerr)

    if (CEGUI_BUILD_RENDERER_DIRECT3D9)
        cegui_target_link_libraries(${CEGUI_TARGET_NAME} ${CEGUI_DIRECT3D9_RENDERER_LIBNAME} d3d9)
    endif()

    if (CEGUI_BUILD_RENDERER_DIRECT3D10)
        cegui_target_link_libraries(${CEGUI_TARGET_NAME} ${CEGUI_DIRECT3D10_RENDERER_LIBNAME} d3d10)
    endif()

    if (CEGUI_BUILD_RENDERER_DIRECT3D11)
        cegui_target_link_libraries(${CEGUI_TARGET_NAME} ${CEGUI_DIRECT3D11_RENDERER_LIBNAME} d3d11)
    endif()

endif()

if (CEGUI_BUILD_RENDERER_DIRECTFB)
    cegui_add_dependency(${CEGUI_TARGET_NAME} DIRECTFB)
    cegui_target_link_libraries(${CEGUI_TARGET_NAME} ${CEGUI_DIRECTFB_RENDERER_LIBNAME})
endif()

if (CEGUI_SAMPLES_USE_GTK2)
    cegui_add_dependency(${CEGUI_TARGET_NAME} GTK2)
endif()

if (APPLE)
    set (CEGUI_EXTRA_FRAMEWORKS "-framework Cocoa")

    if (CEGUI_BUILD_RENDERER_OGRE)
        set (CEGUI_EXTRA_FRAMEWORKS "${CEGUI_EXTRA_FRAMEWORKS} -framework IOKit -framework Carbon")
    endif()

    set_target_properties(${CEGUI_TARGET_NAME} PROPERTIES
        LINK_FLAGS ${CEGUI_EXTRA_FRAMEWORKS}
    )
endif()

cegui_target_link_libraries(${CEGUI_TARGET_NAME} ${CEGUI_BASE_LIBNAME})

=== tests/CMakeLists.txt ===
cegui_add_test_executable(CEGUITests)

=== cegui/src/CMakeLists.txt ===
set( CEGUI_TARGET_NAME ${CEGUI_BASE_LIBNAME} )

# we do not use cegui_gather_files() here since our needs are more complex.
file (GLOB CORE_SOURCE_FILES RELATIVE "${CMAKE_CURRENT_SOURCE_DIR}" *.cpp)
file (GLOB WIDGET_SOURCE_FILES RELATIVE "${CMAKE_CURRENT_SOURCE_DIR}" widgets/*.cpp)
file (GLOB FALAGARD_SOURCE_FILES RELATIVE "${CMAKE_CURRENT_SOURCE_DIR}" falagard/*.cpp)
set (CORE_SOURCE_FILES ${CORE_SOURCE_FILES} ${WIDGET_SOURCE_FILES} ${FALAGARD_SOURCE_FILES})

file (GLOB CORE_HEADER_FILES ../include/CEGUI/*.h)
file (GLOB WIDGET_HEADER_FILES ../include/CEGUI/widgets/*.h)
file (GLOB FALAGARD_HEADER_FILES ../include/CEGUI/falagard/*.h)

list (APPEND CORE_HEADER_FILES
    ${CMAKE_CURRENT_BINARY_DIR}/../include/CEGUI/Config.h
    ${CMAKE_CURRENT_BINARY_DIR}/../include/CEGUI/ModuleConfig.h
    ${CMAKE_CURRENT_BINARY_DIR}/../include/CEGUI/Version.h
)

# We don't append all to CORE_HEADER_FILES since that would mess up installation
# on systems where files are installed.
set (ALL_HEADER_FILES ${CORE_HEADER_FILES} ${WIDGET_HEADER_FILES} ${FALAGARD_HEADER_FILES})

# never compile this directly, it's included in another file
list (REMOVE_ITEM CORE_SOURCE_FILES minibidi.cpp)

if (NOT CEGUI_HAS_DEFAULT_LOGGER)
    list (REMOVE_ITEM CORE_SOURCE_FILES DefaultLogger.cpp)
endif()

if (NOT CEGUI_HAS_FREETYPE)
    list (REMOVE_ITEM CORE_SOURCE_FILES FreeTypeFont.cpp)
endif()

if (NOT CEGUI_HAS_PCRE_REGEX)
    list (REMOVE_ITEM CORE_SOURCE_FILES PCRERegexMatcher.cpp)
endif()

if (NOT CEGUI_USE_FRIBIDI)
    list (REMOVE_ITEM CORE_SOURCE_FILES FribidiVisualMapping.cpp)
endif()

if (NOT CEGUI_USE_MINIBIDI)
    list (REMOVE_ITEM CORE_SOURCE_FILES MinibidiVisualMapping.cpp)
endif ()

if (NOT CEGUI_HAS_MINIZIP_RESOURCE_PROVIDER)
    list (REMOVE_ITEM CORE_SOURCE_FILES MinizipResourceProvider.cpp)
endif()

if (WIN32)
    list (REMOVE_ITEM CORE_SOURCE_FILES IconvStringTranscoder.cpp)
else()
    list (REMOVE_ITEM CORE_SOURCE_FILES Win32StringTranscoder.cpp)
endif()


# we do not use the common header install function since we need to install to
# multiple sub-dirs.
cegui_add_library_impl(${CEGUI_TARGET_NAME} FALSE CORE_SOURCE_FILES ALL_HEADER_FILES TRUE FALSE)

source_group("Source Files\\widget" FILES ${WIDGET_SOURCE_FILES})
source_group("Source Files\\falagard" FILES ${FALAGARD_SOURCE_FILES})

source_group("Header Files\\widget" FILES ${WIDGET_HEADER_FILES})
source_group("Header Files\\falagard" FILES ${FALAGARD_HEADER_FILES})

if (NOT WIN32)
    cegui_add_dependency(${CEGUI_TARGET_NAME} ICONV)
endif()

if (CEGUI_HAS_FREETYPE)
    cegui_add_dependency(${CEGUI_TARGET_NAME} FREETYPE)
endif ()

if (CEGUI_HAS_PCRE_REGEX)
    cegui_add_dependency(${CEGUI_TARGET_NAME} PCRE)
endif ()

if (CEGUI_USE_FRIBIDI)
    cegui_add_dependency(${CEGUI_TARGET_NAME} FRIBIDI)
endif ()

if (CEGUI_HAS_MINIZIP_RESOURCE_PROVIDER)
    cegui_add_dependency(${CEGUI_TARGET_NAME} MINIZIP)
endif ()

if (WIN32 AND NOT MINGW)
    cegui_target_link_libraries(${CEGUI_TARGET_NAME} winmm debug DbgHelp)
elseif (UNIX AND NOT APPLE)
    # This is intentionally not using 'cegui_target_link_libraries'
    target_link_libraries(${CEGUI_TARGET_NAME} ${CMAKE_DL_LIBS})
elseif (MINGW)
    cegui_target_link_libraries(${CEGUI_TARGET_NAME} ${CMAKE_DL_LIBS})
endif()

if (APPLE AND CEGUI_BUILD_SHARED_LIBS_WITH_STATIC_DEPENDENCIES)
    set_property(TARGET ${CEGUI_TARGET_NAME} APPEND PROPERTY LINK_FLAGS "-framework Carbon")
endif()

install(FILES ${CORE_HEADER_FILES} DESTINATION ${CEGUI_INCLUDE_INSTALL_DIR}/CEGUI)
install(FILES ${WIDGET_HEADER_FILES} DESTINATION ${CEGUI_INCLUDE_INSTALL_DIR}/CEGUI/widgets)
install(FILES ${FALAGARD_HEADER_FILES} DESTINATION ${CEGUI_INCLUDE_INSTALL_DIR}/CEGUI/falagard)

=== samples/GLESTest/CMakeLists.txt ===
cegui_add_sample(CEGUIGLESTest)

cegui_target_link_libraries(${CEGUI_TARGET_NAME} ${CEGUI_OPENGLES_RENDERER_LIBNAME})
cegui_add_dependency(${CEGUI_TARGET_NAME} OPENGLES)

=== samples/InventoryDemo/CMakeLists.txt ===
option(CEGUI_SAMPLES_ENABLE_INVENTORY_DEMO "Specifies whether this sample should be built or not" TRUE)
if(CEGUI_SAMPLES_ENABLE_INVENTORY_DEMO)
    cegui_add_sample(CEGUIInventoryDemo)
endif()

=== samples/TextDemo/CMakeLists.txt ===
option(CEGUI_SAMPLES_ENABLE_TEXT_DEMO "Specifies whether this sample should be built or not" TRUE)
if(CEGUI_SAMPLES_ENABLE_TEXT_DEMO)
    cegui_add_sample(CEGUITextDemo)
endif()

=== cegui/src/ImageCodecModules/CMakeLists.txt ===
if (CEGUI_BUILD_IMAGECODEC_CORONA)
    add_subdirectory(Corona)
endif()

if (CEGUI_BUILD_IMAGECODEC_DEVIL)
    add_subdirectory(DevIL)
endif()

if (CEGUI_BUILD_IMAGECODEC_FREEIMAGE)
    add_subdirectory(FreeImage)
endif()

if (CEGUI_BUILD_IMAGECODEC_SILLY)
    add_subdirectory(SILLY)
endif()

if (CEGUI_BUILD_IMAGECODEC_STB)
    add_subdirectory(STB)
endif()

if (CEGUI_BUILD_IMAGECODEC_TGA)
    add_subdirectory(TGA)
endif()

if (CEGUI_BUILD_IMAGECODEC_PVR)
    add_subdirectory(PVR)
endif()

=== cegui/src/XMLParserModules/CMakeLists.txt ===
if (CEGUI_BUILD_XMLPARSER_EXPAT)
    add_subdirectory(Expat)
endif()

if (CEGUI_BUILD_XMLPARSER_XERCES)
    add_subdirectory(Xerces)
endif()

if (CEGUI_BUILD_XMLPARSER_LIBXML2)
    add_subdirectory(Libxml2)
endif()

if (CEGUI_BUILD_XMLPARSER_TINYXML)
    add_subdirectory(TinyXML)
endif()

if (CEGUI_BUILD_XMLPARSER_RAPIDXML)
    add_subdirectory(RapidXML)
endif()

=== cegui/src/ImageCodecModules/DevIL/CMakeLists.txt ===
set (CEGUI_TARGET_NAME ${CEGUI_DEVIL_IMAGECODEC_LIBNAME})

cegui_gather_files()
cegui_add_loadable_module(${CEGUI_TARGET_NAME} CORE_SOURCE_FILES CORE_HEADER_FILES)

cegui_add_dependency(${CEGUI_TARGET_NAME} IL)

cegui_target_link_libraries(${CEGUI_TARGET_NAME} ${CEGUI_BASE_LIBNAME})

=== debian/changelog ===
cegui-mk2 (0.8.4+dfsg-4ubuntu1) xenial; urgency=medium

  * Stop preferring libpng16-dev, trust the archive to know what's best.

 -- Adam Conrad <adconrad@ubuntu.com>  Wed, 13 Apr 2016 09:41:25 -0600

cegui-mk2 (0.8.4+dfsg-4) unstable; urgency=medium

  [ Muammar El Khatib ]
  * The SampleFramework was deactivated due to missing OpenGL dependencies
    (GLFW library). In this revision libglfw-dev was added to fulfill this.
  * debian/control:
    + Build-depends on: libglfw-dev, libfribidi-dev, libirrlicht-dev,
    libdirectfb-dev, libgtk2.0-dev, libminizip-dev, librapidxml-dev.

 -- Muammar El Khatib <muammar@debian.org>  Tue, 12 Jan 2016 21:49:56 +0100

cegui-mk2 (0.8.4+dfsg-3) unstable; urgency=medium

  [ Tobias Frost ]
  * Team upload.
  * d/control: Add VCS-* field point to collab-maint on alioth.
  * Update watchfile.

  [ Muammar El Khatib ]
  * Package build fine with GLEW 1.12.0. (Closes: #790958)
  * CEGUI now is built with libpng16. (Closes: #809886)
  * debian/copyright:
    + The file datafiles/fonts/RichStyle.ttf is licensed under "Ubuntu Font
    License 1.0".
    + License CC-BY-SA for promo/* has been corrected in this revision.
  * The file ./datafiles/fonts/mizufalp.ttf is not redistributable, and now
    has been taken out from the pristine tarball.
  * Embedded javascript library jquery.js was linked against the one provided
    by libjs-jquery package.
  * debian/control:
    + Build-Depends on libjs-jquery.

 -- Muammar El Khatib <muammar@debian.org>  Sun, 10 Jan 2016 01:11:43 +0100

cegui-mk2 (0.8.4-2) unstable; urgency=medium

  * debian/copyright file has been improved in this new revision.
  * debian/control:
    + Build-Depends on libglew-dev.

 -- Muammar El Khatib <muammar@debian.org>  Wed, 22 Jul 2015 15:22:20 +0200

cegui-mk2 (0.8.4-1) unstable; urgency=low

  * New upstream version.
  * Bump Standards-Version to 3.9.6.
  * debian/control:
    + CMAKE dependency added.
    + liblua5.1-expat-dev build-dependency was changed to lua-expat-dev.
      (Closes: #729649)
        + doxygen, and graphviz has been added as a build-dependency to compile
      the documentation of CEGUI.
    + automake1.9 has been dropped.
    + ${shlibs:Depends} added to libcegui-mk2-dev package.
    + Build-Depends on libogre-1.9-dev. (Closes: #732723)
    + libcegui-mk2-dev depends on liblcms2-dev.
  * debian/patches:
    + CMakeLists.txt was modified so that cmake is able to find Boost. For
      more information about the change made, check cmakelistchanges.
  * debian/rules:
    + All rules to autotools has been dropped. (Closes: #724357)
  * debian/README.source file has been deleted. This file is not needed
    anymore, given that dpkg-source -x is capable of applying the patches. For
    more information, please refer to:
        https://wiki.debian.org/Projects/DebSrc3.0

 -- Muammar El Khatib <muammar@debian.org>  Sun, 24 May 2015 12:02:20 +0200

cegui-mk2 (0.7.6-3.3) unstable; urgency=medium

  * Non-maintainer upload.
  * Remove unneeded dependency on liblcms-dev (Closes: #745530) and libmng-dev
    which would also pull-in lcms.

 -- Tobias Frost <tobi@debian.org>  Sun, 03 Aug 2014 19:09:41 +0200

cegui-mk2 (0.7.6-3.2) unstable; urgency=medium

  * Non-maintainer upload.
  * debian/control: Switch to automake1.11. (Closes: #724357)

 -- Eric Dorland <eric@debian.org>  Mon, 03 Mar 2014 22:54:44 -0500

cegui-mk2 (0.7.6-3.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Fix "boost 1.53 is going away" Removing versioned dependencies
    (Closes: #731019)

 -- Tobias Frost <tobi@coldtobi.de>  Sat, 11 Jan 2014 14:47:21 +0000

cegui-mk2 (0.7.6-3) unstable; urgency=low

  * Bump Standards-Version to 3.9.4.
  * debian/control:
    + OGRE dependency was updated to 1.8. (Closes: #704781)
    + Boost dependency was updated to 1.53.

 -- Muammar El Khatib <muammar@debian.org>  Sun, 14 Aug 2013 20:41:39 +0200

=== debian/control ===
Source: cegui-mk2
Section: libs
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Muammar El Khatib <muammar@debian.org>
Build-Depends: debhelper (>= 6), cdbs, libtool, automake, autoconf,
               pkg-config, libxerces-c-dev, libboost-signals-dev,
               libboost-regex-dev, libfreetype6-dev,
               libtiff-dev, libgl1-mesa-dev, libglu1-mesa-dev, libdevil-dev,
               libpcre3-dev, lua-expat-dev, lua5.1, libois-dev [linux-any],
               libfreeimage-dev, libxcursor-dev, libxpm-dev, python-dev,
               libpng-dev, libxxf86vm-dev, libexpat1-dev,
               libxml2-dev, libsilly-dev, libogre-1.9-dev,
               libglew-dev, libtinyxml-dev, libtolua++5.1-dev (>= 1.0.93),
               cmake, graphviz, doxygen, libglm-dev, libjs-jquery, libglfw-dev,
               libfribidi-dev, libirrlicht-dev, libdirectfb-dev, libgtk2.0-dev,
               libminizip-dev, librapidxml-dev
Standards-Version: 3.9.6
Homepage: http://www.cegui.org.uk/
VCS-Browser: https://anonscm.debian.org/cgit/collab-maint/cegui-mk2.git
VCS-Git: git://anonscm.debian.org/collab-maint/cegui-mk2.git

Package: libcegui-mk2-0.8.4
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Conflicts: libcegui-mk2-0c2a
Replaces: libcegui-mk2-0c2a
Description: Crazy Eddie's GUI (libraries)
 CEGUI is a free library providing windowing and widgets for graphics
 APIs and engines where such functionality is not natively available
 or is severely lacking. The library is written in C++, is object
 oriented, and is primarily targeted at games developers who should be
 spending their time creating great games, not building GUI sub-systems
 .
 This version of CEGUI natively supports the OpenGL rendering target.

Package: libcegui-mk2-0.8.4-dbg
Section: debug
Priority: extra
Architecture: any
Depends: ${shlibs:Depends}, libcegui-mk2-0.8.4 (= ${binary:Version}),
         ${misc:Depends}
Conflicts: libcegui-mk2-0-dbg
Replaces: libcegui-mk2-0c2a-dbg
Description: Crazy Eddie's GUI (debugging libraries)
 CEGUI is a free library providing windowing and widgets for graphics
 APIs and engines where such functionality is not natively available
 or is severely lacking. The library is written in C++, is object
 oriented, and is primarily targeted at games developers who should be
 spending their time creating great games, not building GUI sub-systems
 .
 This version of CEGUI natively supports the OpenGL rendering target
 and provides debugging libraries for it.

Package: libcegui-mk2-dev
Section: libdevel
Architecture: any
Suggests: libcegui-mk2-0.8.4-doc
Depends: ${shlibs:Depends}, ${misc:Depends}, libcegui-mk2-0.8.4 (= ${binary:Version}),
         libdevil-dev, libxerces-c3.1, libpng-dev,
         libtiff5-dev | libtiff-dev, libjpeg-dev, libmng-dev,
         zlib1g-dev | libz-dev, libfreetype6-dev, lua-expat-dev, liblcms2-dev,
         libpcre3-dev, libfreeimage-dev
Description: Crazy Eddie's GUI (development files)
 CEGUI is a free library providing windowing and widgets for graphics
 APIs and engines where such functionality is not natively available
 or is severely lacking. The library is written in C++, is object
 oriented, and is primarily targeted at games developers who should be
 spending their time creating great games, not building GUI sub-systems
 .
 This version of CEGUI natively supports the OpenGL rendering target
 and contains the development files for CEGUI.

Package: libcegui-mk2-doc
Section: doc
Architecture: all
Depends: ${misc:Depends}
Description: Crazy Eddie's GUI (documentation)
 CEGUI is a free library providing windowing and widgets for graphics
 APIs and engines where such functionality is not natively available
 or is severely lacking. The library is written in C++, is object
 oriented, and is primarily targeted at games developers who should be
 spending their time creating great games, not building GUI sub-systems
 .
 This package contains the documentation, and example files for CEGUI.

=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/cdbs/1/class/cmake.mk
include /usr/share/cdbs/1/rules/debhelper.mk
LDFLAGS+=-llua5.1 -ldl
DEB_CMAKE_EXTRA_FLAGS= -DBoost_INCLUDE_DIR=/usr/include -DCEGUI_BUILD_RENDERER_DIRECTFB=OFF \
			-DCEGUI_SAMPLES_USE_DIRECTFB=OFF -DCEGUI_BUILD_RENDERER_OPENGL=ON \
			-DCEGUI_SAMPLES_USE_OGRE=ON -DCEGUI_BUILD_XMLPARSER_EXPAT=ON \
			-DCEGUI_BUILD_IMAGECODEC_SILLY=ON -DCEGUI_BUILD_IMAGECODEC_DEVIL=ON\
			-DCEGUI_BUILD_IMAGECODEC_FREEIMAGE=ON -DCEGUI_BUILD_RENDERER_NULL=ON \
			-DCEGUI_BUILD_PYTHON_MODULES=ON -DCEGUI_BUILD_XMLPARSER_TINYXML=ON\
			-DCEGUI_BUILD_XMLPARSER_XERCES=ON

common-configure-arch common-configure-indep::
	cd $(DEB_SRCDIR) && \
	  if ! test -f aclocal.m4 ; then touch aclocal.m4 ; fi

clean::
	rm -f $(DEB_SRCDIR)/bin/Demo6 $(DEB_SRCDIR)/bin/Demo7 $(DEB_SRCDIR)/bin/Demo8 \
	$(DEB_SRCDIR)/bin/DragDropDemo $(DEB_SRCDIR)/bin/FalagardDemo1 \
	$(DEB_SRCDIR)/bin/FirstWindow $(DEB_SRCDIR)/bin/FontDemo $(DEB_SRCDIR)/bin/Minesweeper \
	$(DEB_SRCDIR)/bin/ScrollablePaneDemo $(DEB_SRCDIR)/bin/TabControlDemo  \
	$(DEB_SRCDIR)/bin/TextDemo $(DEB_SRCDIR)/bin/TreeDemo $(DEB_SRCDIR)/bin/InventoryDemo
	rm -f $(DEB_SRCDIR)/config.log $(DEB_SRCDIR)/conftstm.o $(DEB_SRCDIR)/doc/doxygen/doxyfile
	rm -rf $(DEB_SRCDIR)/obj-x86_64-linux-gnu
	rm -rf $(DEB_SRCDIR)/doc/doxygen/html/ $(DEB_SRCDIR)/doc/doxygen/doxygen_sqlite3.db

install/libcegui-mk2-doc::
	doxygen doc/doxygen/doxyfile.in
	cp -rf $(DEB_SRCDIR)/doc/doxygen/html/ \
	$(DEB_SRCDIR)/debian/libcegui-mk2-doc/usr/share/doc/libcegui-mk2-0.8.4/
	rm -f $(DEB_SRCDIR)/debian/libcegui-mk2-docc/usr/share/doc/libcegui-mk2-0.8.4/html/jquery.js
	#These rules are deleting duplicated fonts.
	rm -f $(DEB_SRCDIR)/debian/libcegui-mk2-doc/usr/share/cegui-0.8.4/fonts/DejaVuSans.ttf  \
	      $(DEB_SRCDIR)/debian/libcegui-mk2-doc/usr/share/cegui-0.8.4/fonts/DejaVuSerif.ttf \
	      $(DEB_SRCDIR)/debian/libcegui-mk2-doc/usr/share/cegui-0.8.4/fonts/Junicode.ttf \
	      $(DEB_SRCDIR)/debian/libcegui-mk2-doc/usr/share/cegui-0.8.4/fonts/Jura-DemiBold.ttf \
	      $(DEB_SRCDIR)/debian/libcegui-mk2-doc/usr/share/cegui-0.8.4/fonts/Jura-Light.ttf \
	      $(DEB_SRCDIR)/debian/libcegui-mk2-doc/usr/share/cegui-0.8.4/fonts/Jura-Medium.ttf \
	      $(DEB_SRCDIR)/debian/libcegui-mk2-doc/usr/share/cegui-0.8.4/fonts/batang.ttf

#common-install-arch::
#	for file in debian/tmp/usr/lib/*.la; do \
#	sed -i "/dependency_libs/ s/'.*'/''/" $$file ; \
#	done

#DEB_CONFIGURE_EXTRA_FLAGS := --enable-lua-module=yes --enable-toluacegui=no \
                             --with-default-xml-parser=TinyXMLParser --enable-null-renderer
DEB_DH_INSTALL_SOURCEDIR   := $(DEB_SRCDIR)/debian/tmp

=== debian/watch ===
version=3
opts=dversionmangle=s/\+(debian|dfsg|ds|deb)(\.\d+)?$// \
http://sf.net/crayzedsgui/cegui-(\d\S*)\.(?:zip|tgz|tbz|txz|(?:tar\.(?:gz|bz2|xz)))
